/********************************************************************************
 * Copyright © 2014-2016 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>      *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/


#pragma once


#include <QGroupBox>
#include <QListWidget>
#include <QUrl>


class ExclusionWidget : public QGroupBox
{
    Q_DISABLE_COPY(ExclusionWidget)

public:
    explicit ExclusionWidget();

    inline QList<QRegularExpression> pcre_list() {return pcre_hash.values();}
    inline QList<QUrl> urls_to_exclude_list() {return urls_to_exclude_hash.values();}

    void restore(const QList<QString>&, const QList<QUrl>&);

private:
    QHash<QListWidgetItem*,QRegularExpression> pcre_hash;
    QHash<QListWidgetItem*,QUrl> urls_to_exclude_hash;
    QListWidget* const listwidget = new QListWidget;

    void add_directory();
    void add_files();
    void add_pcre();
    void clear();
    void enable_list(const bool&);
    void remove_items();
};
