/********************************************************************************
 * Copyright © 2014-2016 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>      *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/


#pragma once


#include "exclusionwidget.h"
#include "logger.h"
#include "preparer.h"
#include "urlrequester.h"

#include <KLocalizedString>
#include <KXmlGuiWindow>
#include <QCheckBox>
#include <QPointer>
#include <QRadioButton>
#include <array>


class KFolderSync : public KXmlGuiWindow
{
    Q_DISABLE_COPY(KFolderSync)

public:
    explicit KFolderSync();

private:
    [[gnu::noinline]] ~KFolderSync() = default; // to suppress failed inlining warning
    ExclusionWidget exclusion_widget;
    OperationType selected_operation_type = OperationType::none;
    QCheckBox include_hidden_files_checkbox {i18nc("@option:check", "Include hidden files")};
    QCheckBox log_activity_checkbox {i18nc("@option:check imperative verb", "Log activity")};
    QCheckBox preview_mode_checkbox {i18nc("@option:check", "Preview mode")};
    QCheckBox quit_when_finished_checkbox {i18nc("@option:check", "Quit when finished")};
    QCheckBox use_trash_checkbox {i18nc("@option:check", "Use the trash")};
    QPointer<Logger> logger;
    UrlRequester url_requester;
    const std::array<QRadioButton, 6> radiobutton_array;
    std::pair<QList<QUrl>,QList<QUrl>> operation_url_lists;

    void enable_logger(const bool&);
    void manage_profiles();
    void reset();
    [[gnu::hot]] void run();
};
