/********************************************************************************
 * Copyright © 2014-2016 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>      *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/


#include "logger.h"
#include "logger.moc"

#include <QTextStream>
#include <QTime>


Logger::~Logger()
{
    log_file->close();
    if (Q_UNLIKELY(log_file->size() == 0))
        log_file->remove();
}


bool Logger::open_file(const QString& file_name)
{
    log_file->setFileName(file_name);
    return log_file->open(QFile::Text | QFile::WriteOnly);
}


void Logger::log_kiojob_info(void*, const QString& info_msg, const QString&) {log_message(info_msg);}


void Logger::log_message(const QString& msg)
{
    static QTextStream text_stream(log_file);
    text_stream << '[' << QTime::currentTime().toString(time_format) << "] " << msg << line_separator << endl;
}
