/********************************************************************************
 * Copyright © 2014-2016 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>      *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/


#pragma once


#include <QUrl>
#include <atomic>
#include <deque>


enum class OperationType {bilateral_differential_backup, bilateral_incremental_backup, differential_backup, full_backup, incremental_backup, synchronization, none};


enum class TaskType : quint8 {Copy, Delete, MakeDirectory, Rename, Overwrite};


struct Preparer
{
    struct Results {
        QString error_message;
        std::deque<std::tuple<TaskType,QUrl,QUrl>> task_deque;
    };

    std::atomic_bool abort_preparation {false};

    [[gnu::hot]] Results parse(const OperationType&, const std::pair<QUrl,QUrl>&, const bool&, const QList<QRegularExpression>&, QStringList);

    [[gnu::cold]] [[gnu::noinline]] static void show_bug_and_exit(const char* const, const int&&);
};
