/********************************************************************************
 * Copyright © 2014-2016 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>      *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/


#include "profiledialog.h"
#include "profiledialog.moc"

#include <KLocalizedString>
#include <KStandardGuiItem>
#include <QLabel>
#include <QPushButton>
#include <QVBoxLayout>


ProfileDialog::ProfileDialog(QWidget* const parent) : QDialog(parent, Qt::Dialog)
{
    // Setup widgets
    QPushButton* const load_button = new QPushButton(KStandardGuiItem::open().icon(), i18nc("@action:button", "Load a profile"));
    connect(load_button, &QPushButton::clicked, [&]{selected_action = Load; accept();});
    // ↓
    QPushButton* const save_button = new QPushButton(KStandardGuiItem::save().icon(), i18nc("@action:button", "Save current profile"));
    connect(save_button, &QPushButton::clicked, [&]{selected_action = Save; accept();});
    // ↓
    QPushButton* const delete_button = new QPushButton(KStandardGuiItem::del().icon(), i18nc("@action:button", "Delete a profile"));
    connect(delete_button, &QPushButton::clicked, [&]{selected_action = Delete; accept();});
    // ↓
    const auto& cancel_ksgi = KStandardGuiItem::cancel();
    QPushButton* const cancel_button = new QPushButton(cancel_ksgi.icon(), cancel_ksgi.text());
    connect(cancel_button, &QPushButton::clicked, this, &ProfileDialog::reject, Qt::DirectConnection);
    // ↓
    QVBoxLayout* const this_layout = new QVBoxLayout(this);
    this_layout->addWidget(new QLabel(i18nc("@label", "What would do you like to do?")));
    this_layout->addWidget(load_button);
    this_layout->addWidget(save_button);
    this_layout->addWidget(delete_button);
    this_layout->addWidget(cancel_button);
}
