/********************************************************************************
 * Copyright © 2014-2016 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>      *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/


#pragma once


#include <KIO/Job>
#include <KSqueezedTextLabel>
#include <QDialog>
#include <QProgressBar>


class TaskProgressDialog : public QDialog
{
    Q_OBJECT
    Q_DISABLE_COPY(TaskProgressDialog)

public:
    explicit TaskProgressDialog(QWidget* const);

    void refresh(const int&);
    void register_new_kiojob(KIO::Job* const);
    void wait(const QString&);

private:
    KSqueezedTextLabel* const description_label1 = new KSqueezedTextLabel;
    KSqueezedTextLabel* const description_label2 = new KSqueezedTextLabel;
    KSqueezedTextLabel* const description_label3 = new KSqueezedTextLabel;
    QLabel* const speed_label = new QLabel;
    QProgressBar* const task_progressbar = new QProgressBar;
    QProgressBar* const operation_progressbar = new QProgressBar;
    int step = 0;

    void update_kiojob_description(void*, const QString&, const QPair<QString,QString>&, const QPair<QString,QString>&);

private slots:
    void update_kiojob_speed(KJob*, const ulong&);
    void update_progress_bars(KJob*, const ulong&);
};
